# Use the BigQuery Migration Service MCP server

<br />

This document shows you how to use the BigQuery remote Model Context Protocol (MCP) server to connect with AI applications including Antigravity, ChatGPT, Claude, and custom applications you are developing. You can use the BigQuery Migration Service Model Context Protocol (MCP) server to perform tasks such as translating SQL queries and batches of SQL files into GoogleSQL syntax, translating metadata into DDL statements, generating DDL suggestions from SQL input queries, and getting explanations of SQL translations. The BigQuery remote MCP server is enabled when you enable the BigQuery API.

[Model Context Protocol](https://modelcontextprotocol.io/docs/getting-started/intro)
(MCP) standardizes how large language models (LLMs) and AI applications or
agents connect to external data sources. MCP servers let you use their tools,
resources, and prompts to take actions and get updated data from their backend
service.

## What's the difference between local and remote MCP servers?

Local MCP servers
:   Typically run on your local machine and use the standard input
    and output streams (stdio) for communication between services on the same
    device.

Remote MCP servers
:   Run on the service's infrastructure and offer an HTTP
    endpoint to AI applications for communication between the AI MCP client and
    the MCP server. For more information about MCP architecture, see
    [MCP architecture](https://modelcontextprotocol.io/docs/learn/architecture).

## Stateless core

With
[MCP version 2026-07-28](https://modelcontextprotocol.io/specification/2026-07-28),
MCP changes from a bidirectional, stateful protocol to a stateless protocol.
Each MCP request is self-describing and can be routed using headers. There isn't
a need for the `initialize`/`initialized` handshake or `Mcp-Session-Id` because
each request includes all the information needed in HTTP headers or the `_meta`
parameter. MCP servers can request additional information required by a tool
through
[multi-round-trip requests (MRTR)](https://modelcontextprotocol.io/specification/latest/basic/patterns/mrtr).

To help route and process requests without parsing the request body, some MCP
headers are required, including the following:

- Headers that are required by the MCP specification such as the [protocol version header](https://modelcontextprotocol.io/specification/latest/basic/transports/streamable-http#protocol-version-header) and [standard request headers](https://modelcontextprotocol.io/specification/latest/basic/transports/streamable-http#standard-request-headers).
- [Custom headers](https://modelcontextprotocol.io/specification/latest/basic/transports/streamable-http#custom-headers-from-tool-parameters) that are defined by the MCP server. These headers are mirrored into HTTP headers from the tool's input schema using the `x-mcp-header` property. For example, an MCP server might define a custom header to specify the Google Cloud region or project ID.

For more information about MCP architecture, see the MCP version 2026-07-28
[specification](https://modelcontextprotocol.io/specification/2026-07-28) and
[key changes](https://modelcontextprotocol.io/specification/2026-07-28/changelog).

## Google and Google Cloud remote MCP servers

Google and Google Cloud remote MCP servers have the following features and benefits:

<br />

- Simplified, centralized discovery
- Managed global or regional HTTP endpoints
- Fine-grained authorization
- Optional prompt and response security with Model Armor protection
- Centralized audit logging

For information about other MCP servers and information about security
and governance controls available for Google Cloud MCP servers,
see [Google Cloud MCP servers overview](https://docs.cloud.google.com/mcp/overview.md.txt).

## Before you begin

1.


   Enable the BigQuery Migration Service API, if it is not already enabled.


   **Roles required to enable APIs**


   To enable APIs, you need the `serviceusage.services.enable` permission. If you
   created the project, then you likely already have this permission through the
   Owner role (`roles/owner`). Otherwise, you can get this permission through the
   Service Usage Admin role (`roles/serviceusage.serviceUsageAdmin`).
   [Learn how to grant roles](https://docs.cloud.google.com/iam/docs/granting-changing-revoking-access.md.txt).

   [Enable the API](https://console.cloud.google.com/apis/enableflow?apiid=bigquerymigration.googleapis.com)

### Required roles


To get the permissions that
you need to enable the BigQuery Migration Service MCP server,

ask your administrator to grant you the
following IAM roles on the project where you want to enable the BigQuery Migration Service MCP server:

- Make MCP tool calls: [MCP Tool User](https://docs.cloud.google.com/iam/docs/roles-permissions/mcp.md.txt#mcp.toolUser) (`roles/mcp.toolUser`)
- Use the BigQuery Migration Service: [Migration Workflow Editor](https://docs.cloud.google.com/iam/docs/roles-permissions/bigquerymigration.md.txt#bigquerymigration.editor) (`roles/bigquerymigration.editor`)
- Access Cloud Storage buckets for input and output files: [Storage Object Admin](https://docs.cloud.google.com/iam/docs/roles-permissions/storage.md.txt#storage.objectAdmin) (`roles/storage.objectAdmin`)


For more information about granting roles, see [Manage access to projects, folders, and organizations](https://docs.cloud.google.com/iam/docs/granting-changing-revoking-access.md.txt).


These predefined roles contain

the permissions required to enable the BigQuery Migration Service MCP server. To see the exact permissions that are
required, expand the **Required permissions** section:


#### Required permissions

The following permissions are required to enable the BigQuery Migration Service MCP server:

- Make MCP tool calls: `mcp.tools.call`
- Use the BigQuery Migration Service:
  - `bigquerymigration.workflows.create`
  - `bigquerymigration.workflows.get`
  - `bigquerymigration.workflows.list`
  - `bigquerymigration.workflows.delete`
  - `bigquerymigration.subtasks.get`
  - `bigquerymigration.subtasks.list`
- Access Cloud Storage buckets for input and output files:
  - `storage.objects.get`
  - `storage.objects.list`
  - `storage.objects.create`


You might also be able to get
these permissions
with [custom roles](https://docs.cloud.google.com/iam/docs/creating-custom-roles.md.txt) or
other [predefined roles](https://docs.cloud.google.com/iam/docs/roles-overview.md.txt#predefined).

Additional BigQuery Migration Service permissions might be required depending
on the task. For information about BigQuery Migration Service roles and
permissions, see [BigQuery Migration Service roles and permissions](https://docs.cloud.google.com/iam/docs/roles-permissions/bigquerymigration.md.txt).

## Authentication and authorization

BigQuery Migration Service MCP servers use the [OAuth 2.0](https://developers.google.com/identity/protocols/oauth2)
protocol with [Identity and Access Management (IAM)](https://docs.cloud.google.com/iam/docs/overview.md.txt) for
authentication and authorization. All [Google Cloud identities](https://docs.cloud.google.com/docs/authentication/identity-products.md.txt)
are supported for authentication to MCP servers.

The BigQuery Migration Service MCP server doesn't accept API keys.

## BigQuery Migration Service MCP OAuth scopes

OAuth 2.0 uses scopes and credentials to determine if an authenticated
principal is authorized to take a specific action on a resource. For more
information about OAuth 2.0 scopes at Google, see
[Using OAuth 2.0 to access Google APIs](https://developers.google.com/identity/protocols/oauth2).

BigQuery Migration Service has the following MCP tool OAuth scopes:

| Scope URI for gcloud CLI | Description |
|---|---|
| `https://www.googleapis.com/auth/bigquerymigration` | View and manage your workflows in BigQuery Migration Service and see the email address for your Google Account. |
| `https://www.googleapis.com/auth/devstorage.read_only` | This scope is required for tools that read input files from Cloud Storage, such as metadata files, batch translation inputs, and batch DDL suggestion inputs. |

Resources accessed during a tool call might require additional scopes.

## Configure an MCP client to use the BigQuery Migration Service MCP server

AI applications and agents, such as Claude or Antigravity, can instantiate an MCP client that connects to a single MCP server. An AI application can have multiple clients that connect to different MCP servers. If your application isn't listed in the [client-specific guidance](https://docs.cloud.google.com/mcp/configure-mcp-ai-application.md.txt#client-specific-guidance), then you can use the following information to connect from most applications.

### Register the MCP server using `add-mcp`

You can automatically register the BigQuery Migration Service MCP server into
supported AI clients by using
[`add-mcp`](https://github.com/neon-solutions/add-mcp) without manually
locating configuration file paths. The tool detects your installed AI clients
automatically. The following example shows how to use `add-mcp` to register the
BigQuery Migration Service MCP server:

```bash
npx add-mcp https://bigquerymigration.googleapis.com/mcp --name bqms --header "x-goog-user-project: PROJECT_ID" --scopes "https://www.googleapis.com/auth/bigquerymigration,https://www.googleapis.com/auth/devstorage.read_only" --timeout 30000
```
>
> > [!NOTE]
> > **Note:** When you use `google_credentials` for authentication, `add-mcp` hardens written configurations by emitting standard MCP fields and dropping vendor-specific properties like `authProviderType: "google_credentials"`. For clients that require Google Cloud OAuth credentials (such as Antigravity or Gemini CLI), ensure that `"authProviderType": "google_credentials"` and `"oauth": { "scopes": [...] }` are included in your JSON configuration.
>
In your AI application, look for a way to add or connect to a remote MCP server.
For the BigQuery Migration Service MCP server, enter the following
information as required:

- **Server name**: BigQuery Migration Service MCP server
- **Server URL** or **Endpoint**: bigquerymigration.googleapis.com/mcp
- **Transport** : [Streamable HTTP](https://modelcontextprotocol.io/specification/latest/basic/transports/streamable-http)
- **Authentication details** : depending on how you want to authenticate, you can enter your Google Cloud credentials, your OAuth Client ID and secret, or an agent identity and credentials. For more information about authentication, see [Authenticate to MCP servers](https://docs.cloud.google.com/mcp/authenticate-mcp.md.txt).
- **OAuth scope** : the [OAuth 2.0 scope](https://developers.google.com/identity/protocols/oauth2/scopes) that you want to use when connecting to the BigQuery Migration Service MCP server.

```json
{
  "name": "BQMS-MCP",
  "version": "1.0.0",
  "mcpServers": {
    "BigQueryMigration": {
      "httpUrl": "https://bigquerymigration.googleapis.com/mcp",
      "authProviderType": "google_credentials",
      "oauth": {
        "scopes": [
          "https://www.googleapis.com/auth/bigquerymigration",
          "https://www.googleapis.com/auth/devstorage.read_only"
        ]
      },
      "timeout": 30000,
      "headers": {
        "x-goog-user-project": "PROJECT_ID"
      }
    }
  }
}
```

### Redirect URIs

For web-based applications, and some desktop applications, you must allowlist a
redirect URI when you create a client ID and secret for authentication.
Redirect URIs are used by the authorization server to send tokens
to your application. Your application's documentation should specify the
redirect URI that you must use. [Custom redirect URIs](https://developers.google.com/identity/protocols/oauth2/native-app#redirect-uri_custom-scheme)
aren't supported.
For application-specific guidance about setting up and connecting to MCP server, see [Client-specific guidance](https://docs.cloud.google.com/mcp/configure-mcp-ai-application.md.txt#client-specific-guidance).

For more general guidance, see the following resources:

- [Connect to remote MCP servers](https://modelcontextprotocol.io/docs/develop/connect-remote-servers).
- [Configure MCP in an AI application](https://docs.cloud.google.com/mcp/configure-mcp-ai-application.md.txt).

## Available tools

To view details of available MCP tools and their descriptions for the
BigQuery Migration Service MCP server, see the [BigQuery Migration Service MCP
reference](https://docs.cloud.google.com/bigquery/docs/reference/migration/mcp).

### List tools

Use the [MCP inspector](https://modelcontextprotocol.io/docs/tools/inspector) to list tools, or send a
`tools/list` HTTP request directly to the BigQuery Migration Service
remote MCP server. The `tools/list` method doesn't require authentication.

    curl -X POST https://bigquerymigration.googleapis.com/TOOLSET_ENDPOINT \
        -H 'Content-Type: application/json' \
        -H 'Accept: application/json' \
        -H 'MCP-Protocol-Version: MCP_PROTOCOL_VERSION' \
        -H 'Mcp-Method: tools/list' \
        -d '{
          "jsonrpc": "2.0",
          "id": 1,
          "method": "tools/list",
          "params": {
            "_meta": {
              "io.modelcontextprotocol/protocolVersion": "MCP_PROTOCOL_VERSION",
              "io.modelcontextprotocol/clientCapabilities": {
                "extensions": {
                  "io.modelcontextprotocol/ui": {
                    "mimeTypes": ["text/html;profile=mcp-app"]
                  }
                }
              }
            }
          }
        }'

Replace the following:

- <var translate="no">`TOOLSET_ENDPOINT`</var>: the remainder of the MCP endpoint after the service name. For BigQuery Migration Service, this is `mcp`.
- <var translate="no">`MCP_PROTOCOL_VERSION`</var>: the MCP protocol version. For example, `2026-07-28`.

## Sample use cases

The following are sample use cases for the BigQuery Migration Service MCP
server:

- Using an MCP client with an IDE, translate a query file into GoogleSQL syntax.
- Using an MCP client without an IDE, translate a specified query into GoogleSQL syntax.
- Assess translation quality.
- Get explanations of SQL translations.
- Generate a DDL statement for a specified query.
- Translate a directory of SQL files that are stored in Cloud Storage into GoogleSQL syntax.
- Translate a metadata ZIP file from your source system into DDL statements for BigQuery.
- Generate DDL statements for the tables and views that a batch of SQL files references.

### Sample prompts

You can use the following sample prompts to create and manage
BigQuery Migration Service resources:

#### Translate a query

Use the following prompts to translate a query, assess quality, explain
translations, or generate DDL suggestions:

- Translate the <var translate="no">`DIALECT`</var> query in this
  <var translate="no">`FILENAME`</var>. Use <var translate="no">`PROJECT_ID`</var> and
  <var translate="no">`LOCATION`</var>. Persist the output and translation logs
  into separate directories.

  When you use this prompt, the MCP client calls the `translate_query` tool to
  translate the query in the specified file. The MCP client periodically calls
  the `get_translation` tool to get the results. After the translation
  completes, the client writes the output to the output directory and the logs
  to the logs directory.
- Translate this query from <var translate="no">`DIALECT`</var>:
  <var translate="no">`QUERY`</var>. Use <var translate="no">`PROJECT_ID`</var> and
  <var translate="no">`LOCATION`</var>.

  When you use this prompt, the MCP client calls the `translate_query` tool to
  translate the specified query and displays the translation results.
- Assess the translation quality.

  When you use this prompt, the MCP client reads and examines the translation
  logs and displays a summary of the translation issues with suggested next
  steps.
- Explain the translation.

  When you use this prompt, the MCP client calls the `explain_translation`
  tool to get an explanation of the translation. If the translation logs
  contain `RelationNotFound` or `AttributeNotFound` errors, the MCP client
  should suggest that you [create a metadata package](https://docs.cloud.google.com/bigquery/docs/generate-metadata.md.txt).
  If you can't generate the metadata, you can send a prompt that requests the
  DDL statement.

  A sample response looks like the following:

  ```text
  The translated code converts Teradata-specific features into their
  BigQuery equivalents. Here's a breakdown of the key changes:
  * `MACRO` to `PROCEDURE`: The `YourMacroName` macro was converted
  into a BigQuery stored procedure because
  BigQuery doesn't support macros.
  * `SELECT INTO` to `SET`:
    * For setting multiple `OUT` parameters in `YourStoredProcedureName`, the
      `SELECT ... INTO` is changed to `SET (...) = (SELECT STRUCT(...))`.
    * For single variable assignment in `YourOtherProcedureName`,
      `SELECT ... INTO` is replaced by `SET variable = (SELECT ...)` which is
      the standard in BigQuery.
  * Atomic Operations to `MERGE: The BEGIN REQUEST ... END REQUEST` blocks in
    the `ProcedureA`, `ProcedureB`, and `ProcedureC` procedures,
    which perform atomic "update or insert" operations, are translated into
    standard SQL `MERGE` statements. This is the correct and modern way to
    handle this logic in BigQuery.
  ```
- Generate DDL for this input query.

  The MCP client calls the `generate_ddl_suggestion` tool to start a
  suggestion job. The client gets the suggestion results by calling the
  `fetch_ddl_suggestion` tool. When the suggestion is available, the MCP
  client displays it.

  If the DDL statements are correct, you can send a prompt to prepend the
  generated DDL statements to the query to improve the translation quality.
- Prepend the generated DDL statements to the input query and retranslate.

  When you use this prompt, the MCP client prepends the DDL statements to the
  original input query and calls the `translate_query` tool. The client calls
  the `get_translation` tool to get the translation. The new query translation
  and the logs persist when they're available.

  If the generated DDL statements are correct, any `RelationNotFound` or
  `AttributeNotFound` errors should be resolved which results in improved
  translation quality.

#### Translate batch queries

Use the following prompts to translate SQL files or metadata files that are
stored in Cloud Storage, or to generate DDL suggestions for a batch of SQL
files:

- Translate the <var translate="no">`DIALECT`</var> SQL files in
  <var translate="no">`SOURCE_URI`</var> into GoogleSQL and write the
  output to <var translate="no">`TARGET_URI`</var>. Use
  <var translate="no">`PROJECT_NUMBER`</var> and <var translate="no">`LOCATION`</var>.

  When you use this prompt, the MCP client calls the
  `translate_batch_queries` tool, and then periodically calls the
  `fetch_batch_translation` tool until the translation state is `SUCCEEDED`
  or `FAILED`. The server writes the translated SQL files and the
  `translation_report.csv` summary report to
  <var translate="no">`TARGET_URI`</var>. For more information about the output
  files, see
  [Explore the translation output](https://docs.cloud.google.com/bigquery/docs/batch-sql-translator.md.txt#explore_the_translation_output).

  To improve the translation quality, include a
  [metadata ZIP file](https://docs.cloud.google.com/bigquery/docs/generate-metadata.md.txt) and any
  [configuration YAML files](https://docs.cloud.google.com/bigquery/docs/config-yaml-translation.md.txt) in
  <var translate="no">`SOURCE_URI`</var>. The translator detects these files
  automatically. We recommend that you use an empty
  <var translate="no">`TARGET_URI`</var> for each translation so that the outputs
  of different translations don't mix.
- Translate the <var translate="no">`DIALECT`</var> metadata file
  <var translate="no">`METADATA_FILE_URI`</var> into BigQuery DDL.
  Write the output to <var translate="no">`TARGET_URI`</var>. Use
  <var translate="no">`PROJECT_NUMBER`</var> and <var translate="no">`LOCATION`</var>.

  When you use this prompt, the MCP client calls the `translate_metadata`
  tool, and then periodically calls the `fetch_batch_translation` tool until
  the translation state is `SUCCEEDED` or `FAILED`. The server writes the
  generated DDL statements and table mappings to
  <var translate="no">`TARGET_URI`</var>. If the translation fails, the client
  reads the translation logs from `fetch_batch_translation` to diagnose the
  issue. For more information, see
  [Translate metadata](https://docs.cloud.google.com/bigquery/docs/batch-sql-translator.md.txt#translate_metadata).
- Generate DDL for the <var translate="no">`DIALECT`</var> SQL files in
  <var translate="no">`SOURCE_URI`</var> and write the output to
  <var translate="no">`TARGET_URI`</var>. Use
  <var translate="no">`PROJECT_NUMBER`</var> and <var translate="no">`LOCATION`</var>.

  When you use this prompt, the MCP client calls the
  `generate_batch_ddl_suggestion` tool, and then periodically calls the
  `fetch_batch_ddl_suggestion` tool until the suggestion state is `SUCCEEDED`
  or `FAILED`. The server writes the suggested DDL statements to the
  Cloud Storage directory returned in the `fetch_batch_ddl_suggestion`
  response. To retranslate with the suggested DDL statements, copy them as
  unzipped SQL files to a directory under
  <var translate="no">`SOURCE_URI`</var> and run `translate_batch_queries` again.

  The suggested DDL statements are inferred from how the SQL files use the
  tables and views, so they are approximate. Use this prompt only when you
  can't [generate a metadata ZIP file](https://docs.cloud.google.com/bigquery/docs/generate-metadata.md.txt)
  from your source system. For more information, see
  [Generate source DDL](https://docs.cloud.google.com/bigquery/docs/batch-sql-translator.md.txt#generate_source_ddl).

In the prompts, replace the following:

- <var translate="no">`DIALECT`</var>: the dialect of the SQL query, files, or metadata that you're translating.
- <var translate="no">`QUERY`</var>: the query you're translating.
- <var translate="no">`FILENAME`</var>: the file that contains the query you're translating.
- <var translate="no">`SOURCE_URI`</var>: the Cloud Storage directory that contains the input files, such as `gs://my_bucket/input/`.
- <var translate="no">`TARGET_URI`</var>: the Cloud Storage directory that receives the outputs, such as `gs://my_bucket/output/`.
- <var translate="no">`METADATA_FILE_URI`</var>: the Cloud Storage path of the metadata ZIP file, such as `gs://my_bucket/metadata.zip`. To create this file, see [Generate metadata for translation](https://docs.cloud.google.com/bigquery/docs/generate-metadata.md.txt).
- <var translate="no">`PROJECT_NUMBER`</var>: your Google Cloud [project number](https://docs.cloud.google.com/resource-manager/docs/creating-managing-projects.md.txt#before_you_begin).
- <var translate="no">`LOCATION`</var>: the location of the [SQL translator](https://docs.cloud.google.com/bigquery/docs/locations.md.txt#sql-translator-loc).

## Optional security and safety configurations

MCP introduces new security risks and considerations due to the wide variety of
actions that you can do with the MCP tools. To minimize and manage these risks,
Google Cloud offers default settings and customizable
policies to control the use of MCP tools in your Google Cloud
organization or project.

For more information about MCP security and governance, see
[AI security and safety](https://docs.cloud.google.com/mcp/ai-security-safety.md.txt).

### Use Model Armor

[Model Armor](https://docs.cloud.google.com/model-armor/overview.md.txt) is a
Google Cloud service designed to enhance the security and
safety of your AI applications. It works by proactively screening LLM prompts
and responses, protecting against various risks and supporting responsible AI
practices. Whether you are deploying AI in your cloud environment, or on
external cloud providers, Model Armor can help
you prevent malicious input, verify content safety, protect sensitive data,
maintain compliance, and enforce your AI safety and security policies
consistently across your diverse AI landscape.

When Model Armor is enabled with
[logging enabled](https://docs.cloud.google.com/model-armor/configure-logging.md.txt), Model Armor logs the entire
payload. This might expose sensitive information in your logs.

#### MCP request routing to Model Armor

Model Armor is available in [certain regions](https://docs.cloud.google.com/model-armor/locations.md.txt). When Model Armor is enabled and you use an MCP server in a jurisdiction that Model Armor doesn't support, the routing behavior of the call might be different for different MCP servers and might break data residency compliance for in-use and in-transit data. For more information about the behavior of individual MCP servers, see [Model Armor supported products](https://docs.cloud.google.com/mcp/model-armor-supported-products.md.txt).

#### Enable Model Armor

You must enable Model Armor APIs before you can use Model Armor.

### Console

1.


   Enable the Model Armor API, if it is not already enabled.


   **Roles required to enable APIs**


   To enable APIs, you need the `serviceusage.services.enable` permission. If you
   created the project, then you likely already have this permission through the
   Owner role (`roles/owner`). Otherwise, you can get this permission through the
   Service Usage Admin role (`roles/serviceusage.serviceUsageAdmin`).
   [Learn how to grant roles](https://docs.cloud.google.com/iam/docs/granting-changing-revoking-access.md.txt).

   [Enable the API](https://console.cloud.google.com/apis/enableflow?apiid=modelarmor.googleapis.com)

   <br />

2. Select the project where you want to activate Model Armor.

### gcloud

Before you begin, follow these steps using the Google Cloud CLI with the
Model Armor API:

1.


   In the Google Cloud console, activate Cloud Shell.

   [Activate Cloud Shell](https://console.cloud.google.com/?cloudshell=true)


   At the bottom of the Google Cloud console, a
   [Cloud Shell](https://docs.cloud.google.com/shell/docs/how-cloud-shell-works.md.txt)
   session starts and displays a command-line prompt. Cloud Shell is a shell environment
   with the Google Cloud CLI
   already installed and with values already set for
   your current project. It can take a few seconds for the session to initialize.

   <br />

2.

   Run the following command to set the API endpoint for the
   Model Armor service.

   ```bash
   gcloud config set api_endpoint_overrides/modelarmor "https://modelarmor.LOCATION.rep.googleapis.com/"
   ```

   Replace `LOCATION` with the region where you want to use
   Model Armor.

   <br />

#### Configure protection for Google and Google Cloud remote MCP servers

To help protect your MCP tool calls and responses you can use
Model Armor floor settings. A floor setting defines the minimum
security filters that apply across the project. This configuration applies a
consistent set of filters to all MCP tool calls and responses within
the project.

> [!TIP]
> **Tip:** Don't enable the prompt injection and jailbreak filter unless your MCP traffic carries natural language data.

Set up a Model Armor floor setting with MCP sanitization
enabled. For more information, see [Configure Model Armor floor
settings](https://docs.cloud.google.com/model-armor/configure-floor-settings).

> [!NOTE]
> **Note:** If the agent and the MCP server are in different projects, you can create floor settings in both projects (the client project and the resource project). In this case, Model Armor is invoked twice, once for each project.

See the following example command:

```bash
gcloud model-armor floorsettings update \
--full-uri='projects/PROJECT_ID/locations/global/floorSetting' \
--enable-floor-setting-enforcement=TRUE \
--add-integrated-services=GOOGLE_MCP_SERVER \
--google-mcp-server-enforcement-type=INSPECT_AND_BLOCK \
--enable-google-mcp-server-cloud-logging \
--malicious-uri-filter-settings-enforcement=ENABLED \
--add-rai-settings-filters='[{"confidenceLevel": "MEDIUM_AND_ABOVE", "filterType": "DANGEROUS"}]'
```

Replace `PROJECT_ID` with your Google Cloud project ID.

Note the following settings:

- <var translate="no">`INSPECT_AND_BLOCK`</var>: The enforcement type that inspects content for the Google MCP server and blocks prompts and responses that match the filters.
- <var translate="no">`ENABLED`</var>: The setting that enables a filter or enforcement.
- <var translate="no">`MEDIUM_AND_ABOVE`</var>: The confidence level for the Responsible AI - Dangerous filter settings. You can modify this setting, though lower values might result in more false positives. For more information, see [Model Armor confidence levels](https://docs.cloud.google.com/model-armor/overview.md.txt#ma-confidence-levels).

#### Disable scanning MCP traffic with Model Armor

To stop Model Armor from automatically scanning traffic to and
from Google MCP servers based on the project's floor settings, run the following
command:

```bash
gcloud model-armor floorsettings update \
  --full-uri='projects/PROJECT_ID/locations/global/floorSetting' \
  --remove-integrated-services=GOOGLE_MCP_SERVER
```

Replace `PROJECT_ID` with the Google Cloud project
ID. Model Armor doesn't automatically apply the rules defined in
this project's floor settings to any Google MCP server traffic.

Model Armor floor settings and general configuration can impact
more than just MCP. Because Model Armor integrates with services
like Vertex AI, any changes you make to floor settings can affect
traffic scanning and safety behaviors across all integrated services, not just
MCP.

### Control MCP use with IAM policies

Identity and Access Management (IAM)
[deny policies](https://docs.cloud.google.com/iam/docs/deny-overview.md.txt) and
[allow policies](https://docs.cloud.google.com/iam/docs/allow-policies.md.txt) help you
secure Google Cloud and Google MCP servers.

You can combine multiple criteria to build customized security and governance
policies by allowing or denying access based on the following:

- The principal.
- Tool properties like the read-only attribute.
- The service name or tool name.
- The application's OAuth client ID.

For more information, see
[Control MCP use with Identity and Access Management](https://docs.cloud.google.com/mcp/control-mcp-use-iam.md.txt).

## Quotas and limits

You are still subject to the quotas enforced by the APIs called by the MCP
server tools. The following API methods are called by the MCP server tools:

| Tool | API method | Quotas |
|---|---|---|
| `explain_translation` | [`GetMigrationWorkflow`](https://docs.cloud.google.com/bigquery/docs/reference/migration/rpc/google.cloud.bigquery.migration.v2.md.txt#google.cloud.bigquery.migration.v2.MigrationService.GetMigrationWorkflow) | [BigQuery Migration API quotas and limits](https://docs.cloud.google.com/bigquery/quotas.md.txt#migration-api-limits) |
| `fetch_batch_ddl_suggestion` | [`GetMigrationWorkflow`](https://docs.cloud.google.com/bigquery/docs/reference/migration/rpc/google.cloud.bigquery.migration.v2.md.txt#google.cloud.bigquery.migration.v2.MigrationService.GetMigrationWorkflow) | [BigQuery Migration API quotas and limits](https://docs.cloud.google.com/bigquery/quotas.md.txt#migration-api-limits) |
| `fetch_batch_translation` | [`GetMigrationWorkflow`](https://docs.cloud.google.com/bigquery/docs/reference/migration/rpc/google.cloud.bigquery.migration.v2.md.txt#google.cloud.bigquery.migration.v2.MigrationService.GetMigrationWorkflow) | [BigQuery Migration API quotas and limits](https://docs.cloud.google.com/bigquery/quotas.md.txt#migration-api-limits) |
| `fetch_ddl_suggestion` | [`GetMigrationWorkflow`](https://docs.cloud.google.com/bigquery/docs/reference/migration/rpc/google.cloud.bigquery.migration.v2.md.txt#google.cloud.bigquery.migration.v2.MigrationService.GetMigrationWorkflow) | [BigQuery Migration API quotas and limits](https://docs.cloud.google.com/bigquery/quotas.md.txt#migration-api-limits) |
| `generate_batch_ddl_suggestion` | [`CreateMigrationWorkflow`](https://docs.cloud.google.com/bigquery/docs/reference/migration/rpc/google.cloud.bigquery.migration.v2.md.txt#google.cloud.bigquery.migration.v2.MigrationService.CreateMigrationWorkflow) | [BigQuery Migration API quotas and limits](https://docs.cloud.google.com/bigquery/quotas.md.txt#migration-api-limits) |
| `generate_ddl_suggestion` | [`CreateMigrationWorkflow`](https://docs.cloud.google.com/bigquery/docs/reference/migration/rpc/google.cloud.bigquery.migration.v2.md.txt#google.cloud.bigquery.migration.v2.MigrationService.CreateMigrationWorkflow) | [BigQuery Migration API quotas and limits](https://docs.cloud.google.com/bigquery/quotas.md.txt#migration-api-limits) |
| `get_translation` | [`GetMigrationWorkflow`](https://docs.cloud.google.com/bigquery/docs/reference/migration/rpc/google.cloud.bigquery.migration.v2.md.txt#google.cloud.bigquery.migration.v2.MigrationService.GetMigrationWorkflow) | [BigQuery Migration API quotas and limits](https://docs.cloud.google.com/bigquery/quotas.md.txt#migration-api-limits) |
| `translate_batch_queries` | [`CreateMigrationWorkflow`](https://docs.cloud.google.com/bigquery/docs/reference/migration/rpc/google.cloud.bigquery.migration.v2.md.txt#google.cloud.bigquery.migration.v2.MigrationService.CreateMigrationWorkflow) | [BigQuery Migration API quotas and limits](https://docs.cloud.google.com/bigquery/quotas.md.txt#migration-api-limits) |
| `translate_metadata` | [`CreateMigrationWorkflow`](https://docs.cloud.google.com/bigquery/docs/reference/migration/rpc/google.cloud.bigquery.migration.v2.md.txt#google.cloud.bigquery.migration.v2.MigrationService.CreateMigrationWorkflow) | [BigQuery Migration API quotas and limits](https://docs.cloud.google.com/bigquery/quotas.md.txt#migration-api-limits) |
| `translate_query` | [`CreateMigrationWorkflow`](https://docs.cloud.google.com/bigquery/docs/reference/migration/rpc/google.cloud.bigquery.migration.v2.md.txt#google.cloud.bigquery.migration.v2.MigrationService.CreateMigrationWorkflow) | [BigQuery Migration API quotas and limits](https://docs.cloud.google.com/bigquery/quotas.md.txt#migration-api-limits) |

For more information on BigQuery quotas, see
[Quotas and limits](https://docs.cloud.google.com/bigquery/quotas.md.txt).

## What's next

- Read the [BigQuery Migration Service MCP reference documentation](https://docs.cloud.google.com/bigquery/docs/reference/migration/mcp.md.txt).
- Learn more about [Google Cloud MCP servers](https://docs.cloud.google.com/mcp/overview.md.txt).
- See the MCP [supported products](https://docs.cloud.google.com/mcp/supported-products.md.txt).